diff -uNrd ircd-hybrid-6.3.1.dist/BUGS ircd-hybrid-6.3.1/BUGS
--- ircd-hybrid-6.3.1.dist/BUGS	Wed Dec 31 19:00:00 1969
+++ ircd-hybrid-6.3.1/BUGS	Wed Apr 30 10:28:35 2003
@@ -0,0 +1,20 @@
+This is a list of known bugs/open issues with Hybrid 6.3.1 that will
+likely never be fixed.
+
+o Large numbers of temporary KLINE's cause performance to drop.
+  Depending on the resources of the server, between 2000 and 4000
+  temporary KLINE's will make the server lag.  The solution is only
+  present in ircd-ratbox and hybrid 7's +lmh4 patch, multiple lists,
+  each checked at different times (and intervals).  For large servers,
+  it is not recommended to use tkline times over 1440.
+
+o There are unconfirmed reports of mtrie "losing" klines or ilines with
+  heavy load and large numbers of lines.
+
+o There are unconfirmed reports of a remotely exploitable buffer overflow.
+
+o Duplicate KLINE's can be added by having multiple user@* klines in the
+  conf and issuing REHASH.  This is most often a result of .include'ing
+  kline.conf.
+  NOTE:  This is fixed as of +fr24.
+
diff -uNrd ircd-hybrid-6.3.1.dist/ChangeLog ircd-hybrid-6.3.1/ChangeLog
--- ircd-hybrid-6.3.1.dist/ChangeLog	Wed Apr 17 23:16:01 2002
+++ ircd-hybrid-6.3.1/ChangeLog	Sat Apr 19 21:09:57 2003
@@ -1,3 +1,89 @@
+androsyn    2003/04/06 17:42:04 EDT     (20030406_1)
+
+  Modified files:
+    src                  s_auth.c 
+  Log:
+  The case is inverted on this test.  Take a peek at the example clients in
+  the adns source distribution and you'll see what I mean :)
+  
+  Revision  Changes    Path
+  1.54      +1 -1      ircd-hybrid-6/src/s_auth.c
+
+
+
+androsyn    2003/04/06 17:10:38 EDT     (20030406_0)
+
+  Modified files:
+    include              res.h 
+    src                  adns.c s_auth.c 
+  Log:
+  adns fixes from hybrid-7.  I have yet to see this bug crash a hybrid-6
+  server *but* its still possible, just harder I think.
+  
+  Revision  Changes    Path
+  1.17      +3 -3      ircd-hybrid-6/include/res.h
+  1.11      +6 -6      ircd-hybrid-6/src/adns.c
+  1.53      +3 -3      ircd-hybrid-6/src/s_auth.c
+
+XXX There were some items here that were not included.  These are items
+that I patched manually in +fr.  See the +fr ChangeLog for more information
+
+
+androsyn    2002/08/02 17:57:53 EDT	(20020802_0)
+
+  Modified files:
+    src                  channel.c 
+  Log:
+  Change knock disable to work with +p and not +s.
+  
+  Revision  Changes    Path
+  1.234     +2 -2      ircd-hybrid-6/src/channel.c
+
+
+
+androsyn    2002/07/11 20:04:08 EDT	(20020712_0)
+
+  Modified files:
+    .                    configure 
+    adns                 Makefile.in 
+    autoconf             configure.in 
+    include              setup.h.in 
+  Log:
+  Changes to make configure detect ranlib and use it for libadns.a. This
+  should probably go into a hybrid 6.3.2
+  
+  Revision  Changes    Path
+  1.4       +3 -2      ircd-hybrid-6/adns/Makefile.in
+  1.29      +1 -0      ircd-hybrid-6/autoconf/configure.in
+  1.30      +111 -80   ircd-hybrid-6/configure
+  1.18      +0 -1      ircd-hybrid-6/include/setup.h.in
+
+
+
+androsyn    2002/06/12 15:31:24 EDT	(20020612_0)
+
+  Modified files:
+    src                  sprintf_irc.c 
+  Log:
+  Make %lu return 0 for 0 and not 000000000
+  
+  Revision  Changes    Path
+  1.12      +6 -0      ircd-hybrid-6/src/sprintf_irc.c
+
+
+
+androsyn    2002/04/28 04:13:05 EDT	(20020428_0)
+
+  Modified files:
+    src                  s_conf.c 
+  Log:
+  Fixed a potential NULL dereference in the dns code..
+  
+  Revision  Changes    Path
+  1.237     +1 -1      ircd-hybrid-6/src/s_conf.c
+
+
+
 lusky       2002/04/17 23:15:59 EDT	(20020418_1)
 
   Modified files:
diff -uNrd ircd-hybrid-6.3.1.dist/README.FR ircd-hybrid-6.3.1/README.FR
--- ircd-hybrid-6.3.1.dist/README.FR	Wed Dec 31 19:00:00 1969
+++ ircd-hybrid-6.3.1/README.FR	Sat May 10 13:21:23 2003
@@ -0,0 +1,492 @@
++fr patches - Hwy
+
+The +fr patches are a collection of things I find useful in a Hybrid 6.x
+server.  These are mostly local patches, not affecting the network in any
+way.  The global affecting ones are clearly marked as such.
+
+The current set of features include:
+o The maximum local and global client connections are optionally saved
+  between restarts
+o Optional /quote XLINE, with this comes /quote SET XLINETYPE to define
+  which mode you wish to use for any following XLINE
+o Optional encrypted I: line passwords
+o Optional gecos in the client connection line, same format as hybrid 7
+o Optional "ping cookies", formerly used as an anti-ip spoof measure, now
+  useful in protecting against some drones.
+o Optional unsupported remote /whois notification {global - policy}
+o Optional limited HTTP proxy protection
+o Optional global clone checking {Only limits local users}
+o PART messages {global - unsupporting servers will ignore the parameter}
+o Optional silence on ban {global - policy} (warning, can be CPU intensive)
+o Unauthorized client connections are sent to the +u usermode
+o TOPIC info includes the user@host as well as the nick of the client who
+  set the topic
+o Administrator mode, it currently does not do anything except mark the oper
+  as an administrator
+o csircd like FLAGS command, used in almost the same manner
+o Optional "Quit:" marking of user /quit's
+o Restricted clients (little i: lines) get sent numeric 484 rather than a
+  notice (compatability with hybrid 7 and ircnet 2.10)
+o Optionally notify client who issue STATS and have it ignored {can affect
+  remote users}
+o Optionally notify client who issue a remote WHOIS and have it ignored
+  {can affect remote users}
+o Optionally allow negative ports to be used in C: lines, allowing an
+  administrator to set a port without having it automatically connect.
+  With this comes hybrid 7/ircnet 2.11's /connect server 0 [remote] to
+  use the default port or the port specified in the C: line. {The remote
+  hub has to understand the connect 0 syntax}
+o STATS p shows administrator status
+o Times/dates sent by the server can be localized to the LANG setting in
+  your ircd account's shell
+o The "is now an irc operator" notice displays administrator access.
+o STATS ? shows the TS version of directly linked servers
+o The maximum TKLINE time is changeable with /quote SET
+o The server introduced (+x) notice includes the hop count and server info
+  text (IRCnet and +leguin like) {can break scripts}
+o fl_'s temporary DLINE patch is included
+o billy-jon's resolving hostname patch is included
+o Optional unsupported deoper notices (umode -o and quit)
+o Extended STATS v
+o +l usermode to view LOCOPS
+o Optionally allow opers to join and speak in juped channels {policy}
+o Temporary KLINE expiration notices are optional
+o Optionally propogate AWAY (compliance with hybrid 7 and the next release of
+  csircd), and optionally burst AWAY on top of this {global affecting, uses
+  more bandwidth}
+o Optionally revert USERHOST to RFC specifications (stock Hybrid 7's fixes
+  an issue with mIRC and spoofed hostnames, but can break EPIC and mIRC's
+  userlist)
+o RPL_WELCOME (001) is consistent with hybrid 7
+o Send a NOTICE to opers when /quote CLOSE is used
+o Added MAP
+o Optionally add /wallchops, a compatability shim for undernet users/clients
+o kill -USR1 pid from the command line triggers a REHASH MOTD.
+o Optional blocking of STATS c and ? from non-opers.
+o Corrections and enhancements to GLINE.
+o Adding a permanent kline while a temporary kline exists will remove the
+  temporary kline and add the permanent one in its place.
+o RPL_WHOISACTUALLY, displays the real IP for users as in ircd-ratbox.
+o Removes SLAVE_SERVERS, but allows propagation of remote KLINE/UNKLINE if
+  we are defined as a hub.
+o Adds ENCAP, needed for compatability with ircd-ratbox and csircd.
+o Adds ETRACE, used by modern monitor bots.
+
+o Corrections to stock Hybrid 6.3.1 since release.
+
+Requirements:
+
+You MUST have the following itmes to use this patch:
+o A working snprintf()
+o Working POSIX locale support
+
+Below is basically a ChangeLog of the +fr patch:
+
++fr1
+
+Against 6.3rc1
+Included:  SAVE_MAXCLIENT, XLINE_COMMAND, CRYPT_AUTH_PASSWORD, and
+           GECOS_CLICONNECT
+9 Dec 2001
+
++fr2
+
+Against 6.3rc2
+Added:  ANTI_IP_SPOOF, REMOTE_WHOIS_NOTICE*, POST_REGISTER
+
+* - I do not support this, it was added by request only.
+
+11 Dec 2001
+
++fr3
+
+Against 6.3rc2
+Added:  CHECK_CLONE, IDENT_ANAL
+
+11 Dec 2001
+
++fr4
+
+Against 6.3rc3
+Added:  SEND_ISUPPORT, PART_MESSAGES, SILENCE_ON_BAN, MODE_UNAUTH
+
+12 Dec 2001
+
++fr5
+
+Against 6.3rc3
+Added:  TOPIC_UH, ADMIN_MODE
+Correction To:  REMOTE_WHOIS_NOTICE
+
+12 Dec 2001
+
++fr6
+
+Against 6.3rc3
+Added:  FLAGS_COMMAND, FLAGS_ANNOUNCE
+Changed:  CHECK_CLONE messages now go to +r opers, not +s,
+          Cleanup of CHECK_CLONE
+
+13 Dec 2001
+
++fr7
+
+Against 6.3rc4
+Added:  CLIENT_EXIT
+Correction To:  XLINE_COMMAND, fixed a double free
+Removed:  SEND_ISUPPORT (It's stock H6.3 now)
+Changed:  FLAGS_ANNOUNCE used everywhere it's used on csircd now
+Changed:  The Clone Period and number can be changed with /quote SET
+Changed:  Restricted mode (little i:) clients are sent numeric 484 rather
+          than a NOTICE, like IRCnet and Hyb7.  This can be used to spot
+          eggdrops, as they will QUIT with the message 'i-lines suck'
+          if it gets a 484 numeric.
+
+22 Dec 2001
+
++fr8
+
+Against 6.3rc5
+Added:  STATS_IGNORED_NOTICE, WHOIS_TRYAGAIN
+
+4 Jan 2002
+
++fr9
+
+Against 6.3rc6
+Added:  PRESERVE_SQUIT_REASONS, NEG_PORT
+
+6 Feb 2002
+
++fr10
+
+Against 6.3 release
+Changed:  STATS p now shows admin status in addition to showing local/global
+          Valid characters are:  A O o (x is an error condition that should
+          never happen).
+
+          Admin mode is set by default upon OPER.
+
+Merged:   6.3+locale patch, providing localised, multilingual date settings.
+
+WARNING:  The locale patch thus requires POSIX locale support, and will NOT
+          compile without it.
+
+17 Feb 2002
+
++fr11
+
+Against 6.3 release
+Removed:  PRESERVE_SQUIT_REASONS (I don't believe it's possible with Hybrid
+          6's structure)
+
+Change:  The character shown in the oper NOTICE uses the characters as in
+         STATS p
+
+Merged:  6.3+qotd1 patch, providing a Quote of the day system, disabled
+         by default
+
+24 Feb 2002
+
++fr12
+
+Against 6.3 release
+
+Added:  SIGTRAP handling, for FreeBSD and gdb detach
+Added:  Show TS version for directly linked servers in STATS ?
+
+Merged:  6.3+maxtktime patch, Provide definable maximum TKLINE times,
+         settable with /quote SET
+
+Included:  Patches since 6.3 release
+
+5 Mar 2002
+
++fr13
+
+Against 6.3.1 release
+
+Changed:  Time/Date localization month/day order is not supported on
+          Slackware and likely other Linux machines.  Separated out
+          into "Day Month" order.  They will still have the month names
+          localized, but the order will now be fixed.
+
+Added:  An IRCnet like server connection notice, including the hopcount
+        and info.  (Idea from IRCnet and +leguin)
+
+Merged:  Lee's (fl_'s) temp dline patch (flamed.net)
+Merged:  Bill's (billy-jon's) resolving hostname patch (flamed.net)
+
+Included with 6.3.1:  Patches since 6.3 release, SIGTRAP handling
+
+19 Apr 2002
+
++fr14
+
+Against 6.3.1 release
+
+Changed:  Localization changed to be space padded rather than 0 padded in
+          the day of the month.
+
+Added:  DEOPER_NOTICE (Disabled by default)
+
+Merged:  Lee and jv's STATS v patch
+
+Merged:  Lee's locops umode patch, backported from H7
+
+Merged:  My JUPE Bypass patch, allowing opers to join and speak in juped
+         channels.
+
+14 May 2002
+
++fr15
+
+Changed:  Minor correction to /info from stock Hybrid 6.3.1
+          Added a fix from Androsyn since 6.3.1
+          Made tkline expiration notices optional
+          Made FLAGS work with our +l mode, as LWALLOPS
+
+Removed:  IDENT_ANAL
+
+Added:  PROPAGATE_AWAY, REVERT_USERHOST
+Added:  /quote SET XLINETYPE, allowing an oper with XLINE_COMMAND enabled
+        to change the type of XLINE created.
+
+Corrected:  A case where current set and unset flags NOTICES were sent to
+            the source user twice if FLAGS_ANNOUNCE was enabled.
+
+23 May 2002
+
++fr16
+
+Changed:  Added PUT and GET to POST_REGISTER, backported from current -7
+          RPL_WELCOME (001) made consistent with -7 plus it includes
+            the username and sockhost of the connecting client (an attempt
+            to correct mirc when spoofed)
+
+Added:  Send a notice to opers when a /quote CLOSE is issued
+
+Corrected:  A compile error with XLINE_COMMAND off
+
+24 May 2002
+
++fr17
+
+Against:  6.3.1
+
+Added:  BURST_AWAY, WALLCHOPS, OLD_KNOCK
+
+Added:  /quote MAP (with +y "spy"ing), Temporary DLINE expiration notice is
+        now optional
+
+Changed:  All fixes since 6.3.1 release (possible NULL dereference, LTRACE
+          IP leak, KNOCK change to +p, ranlib check for OpenBSD, %lu to
+          0 instead of 000000000)
+
+Changed:  Updated RPL_ISUPPORT tokens to current "standards"
+
+Changed:  Make the server ignore "unknown user mode" numerics from remote
+          servers.  This is due to an issue where csircd servers will complain
+          about the +a usermode even if it's received from a remote server.
+
+Changed:  Some of the old "show oper reasons in klines/dlines" is back.  The
+          hybrid structure destroys any chance of showing them on
+          /stats k/K/D, unfortunately.
+
+Corrected:  Fixed a core when using locked kline files (such as using viklines)
+            and corrected a race condition where some may become lost in
+            memory.
+
+Changed:  Changed Lee and jv's STATS v extension to be formatted like STATS u
+          and STATS v in ircd-ratbox.
+
+Changed:  Client Exit: becomes Quit: in compliance with hybrid 7 and ratbox.
+
+Changed:  Remote WHOIS notice includes the servername of the source, from
+          dilli
+
+Removed:  QOTD patch, it's better to keep it separate.
+
+4 Sept 2002
+
++fr18
+
+Against:  6.3.1 release
+
+Added:  SHOW_JUPE_MODE
+
+Changed:  All zlib errors still using the error code now use the error string.
+
+Corrected:  A case where an oper could set @host klines, with a NULL user
+            field.
+
+Changed:  MODE_UNAUTH is on permanently
+
+Added:  Added user mode +j, show users trying to join juped channels.  As
+        per request, locally juping and locally unjuping notices are not
+        changed.
+
+23 Sept 2002
+
++fr19
+
+Against:  6.3.1 release
+
+Corrected:  The server field in remote whois notice was in the wrong place.
+
+Corrected:  XLINETYPE was missing from the /set help text, added.
+
+Updated:  mkpasswd.c
+
+Corrected:  An issue where an admin can /umode -o and still be displayed
+            as an IRC administrator.
+
+17 Oct 2002
+
++fr20
+
+Against:  6.3.1 release
+
+Changed:  POST_REGISTER to act more like Androsyn's version in hybrid 7.
+
+Cleaned Up:  FLAGS_COMMAND
+
+Added:  SIGUSR1 handling, rereads the motd file.
+
+25 Nov 2002
+
++fr21
+
+Against:  6.3.1 release
+
+Changed:  Enabled "spy" on LTRACE, showing remote LTRACE requests in
+          addition to local LTRACE requests.
+
+Added:  LTRACE IP hide fix, that seems to have disappeared from Hybrid 6
+        CVS
+
+Added:  GLINE patches/fixes from EFnet opers/admins:
+|========
+|1.  Even though we can't support IPv6, still allow opers on this server
+|    to vote for GLINE's for IPv6 users (As long as the : only exists in
+|    the hostname.)
+|2.  Cosmetic corrections to the "already voted" message.
+|3.  When a gline is triggered, expire any GLINE requests matching it from
+|    the pending list.
+|========
+
+Corrected:  Invalid usage of resource parameters in STATS r (though some
+            remain inaccurate due to overflow of the long values)
+
+Added:  Options to block STATS c and ? from non-opers
+
+6 Jan 2003
+
++fr22
+
+Against:  6.3.1 release
+
+Fixed:  A core that was introduced with the GLINE patch
+
+25 Jan 2003
+
++fr23
+
+Against: 6.3.1 release
+
+Included:  Androsyn's fix for adns from Hybrid 6's cvs.
+NOTE:  Hybrid 6 CVS was NOT chosed as the base for this because of
+ELEET_OPERS, S: lines, and the conflicting +l mode.
+
+Removed:  Numeric 308, RPL_WHOISADMIN.  This is considered vanity on
+EFnet and is thus gone.  It will still be shown in /stats p, I'm awaiting
+a decision in Hybrid 7/ratbox before changing this.
+
+Changed:  vimotd/viklines installed as symbolic links rather than hard
+links as per discusson on hybrid@the-project.org.
+
+Added:  RPL_WHOISACTUALLY, in the ircd-ratbox format, numeric 338.  This
+is intended to help spot DNS spoofers.  This option is always on.
+
+Changed:  ADMIN_MODE is always defined now.
+
+Changed:  When an operator sets a permanent kline, and a temporary kline
+for that user/host/ip already exists, remove the temporary kline and add
+the permanent kline.  If another temporary kline for that user/host/ip
+exists, act as before, don't allow another temporary to override.
+
+Removed:  SLAVE_SERVERS, it doesn't work that well, and is better done in
+other ways.  In addition, it will interfere with the below patch that was
+included.
+
+Included:  fl's KLN/UNKLN propagation patch, needed to allow Hybrid 7/csircd/
+ircd-ratbox remote KLINE and UNKLINE commands to propagate through a Hyb6+fr
+hub.  This functionality does not let users on the server set remote KLINE's
+and UNKLINE's, nor does it let the server accept remote KLINE's and UNKLINE's.
+This functionality is also only available on hubs, since it would do no good
+on a leaf server.
+
+Added:  The ENCAP command, for compatability with ircd-ratbox and csircd.
+Currently, no one uses ENCAP for anything, but the framework and CAPAB are
+both in place for when someone does.
+
+Added:  The ETRACE command, for modern monitor bots that track gecos in
+addition to nick!user@host and class.  Included doc/ETRACE.txt to document
+the change.
+
+Removed:  CUSTOM_ERR, ETRACE requires me to move the last valid numeric from
+504 to 999, and I did not consider CUSTOM_ERR worth my time to migrate.
+
+Changed:  Reformatted MAP to be consistent with ircd-ratbox.
+
+Added:  The I: line flag {, used to exempt a user from the clone checks.
+
+22 Apr 2003
+
++fr24
+
+Updated:  mkpasswd.c from the master site
+
+Updated:  viconf.c from ircd-ratbox
+
+Changed:  Split out m_flags() and support functions into src/m_flags.c and
+include/m_flags.h and put the CORRECT license on the files.
+
+Corrected:  2 cases where duplicate klines could be added to the server
+were fixed.
+
+Corrected:  2 cases where duplicate ilines could be added to the server
+were fixed.
+
+Merged:  Some fixes from xyst's current Hyb6 CVS:
+1.  Removed the id field from struct User.
+2.  Corrections to the logic of ERROR handling, all ERROR's are logged
+    with the real IP.  The other defines only apply to the notice(s) sent
+    to opers.
+3.  Changed the defaulting to class 0 notice.
+
+Added:  Temporary KLINE and DLINE shortcuts, /quote KLINE 1d user@host :blah
+will kline a user for 1 day, 1440 minutes.  d, w, h, m are all accepted,
+and a number without a type specifier will default to minutes.
+
+Removed:  Some unused (anymore) numerics were removed.
+
+Fixed:  Corrected many of the compiler warnings, and allowed CFLAGS to be
+specified on the command line, ie $ CFLAGS="-O2 -g -static" ./configure.  Also
+allowed LDFLAGS to be specified on the command line.
+
+Changed:  KNOCK to use numerics as in Hybrid 7/ircd-ratbox
+
+Changed:  WHOISACTUALLY to be consistant with the recent ircd-ratbox change
+
+5 May 2003
+
++fr25
+
+Corrected:  MacOS-X/Darwin compilation issues
+
+Updated:  mkpasswd.c again
+
+Changed:  WHOISACTUALLY will display if you are spoofed and WHOIS'ing yourself.
+
+Included:  Lee's final ENCAP protocol document.
diff -uNrd ircd-hybrid-6.3.1.dist/adns/.depend ircd-hybrid-6.3.1/adns/.depend
--- ircd-hybrid-6.3.1.dist/adns/.depend	Tue Dec 11 21:02:02 2001
+++ ircd-hybrid-6.3.1/adns/.depend	Sat May  3 10:22:12 2003
@@ -1,4 +1,3 @@
-# $Id .depend,v 0.0 2001/12/09 17:37:18 lusky Exp $
 check.o: check.c internal.h ../include/config.h ../include/setup.h \
  adns.h ../include/irc_string.h ../include/ircd_defs.h dlist.h
 event.o: event.c internal.h ../include/config.h ../include/setup.h \
diff -uNrd ircd-hybrid-6.3.1.dist/adns/check.c ircd-hybrid-6.3.1/adns/check.c
--- ircd-hybrid-6.3.1.dist/adns/check.c	Tue Dec  4 11:12:10 2001
+++ ircd-hybrid-6.3.1/adns/check.c	Thu May  8 11:09:58 2003
@@ -31,6 +31,12 @@
 
 #include "internal.h"
 
+/* This crap is needed to make it compile on OS X
+ * Leave it to apple to take a perfectly good preprocessor and fuck it
+ * up.
+ */
+#define unused_arg /**/
+
 void adns_checkconsistency(adns_state ads, adns_query qu) {
   adns__consistency(ads,qu,cc_user);
 }
@@ -185,16 +191,16 @@
   if (qu) {
     switch (qu->state) {
     case query_tosend:
-      DLIST_ASSERTON(qu, search, ads->udpw, );
+      DLIST_ASSERTON(qu, search, ads->udpw, unused_arg);
       break;
     case query_tcpw:
-      DLIST_ASSERTON(qu, search, ads->tcpw, );
+      DLIST_ASSERTON(qu, search, ads->tcpw, unused_arg);
       break;
     case query_childw:
-      DLIST_ASSERTON(qu, search, ads->childw, );
+      DLIST_ASSERTON(qu, search, ads->childw, unused_arg);
       break;
     case query_done:
-      DLIST_ASSERTON(qu, search, ads->output, );
+      DLIST_ASSERTON(qu, search, ads->output, unused_arg);
       break;
     default:
       assert(!"specific query state");
diff -uNrd ircd-hybrid-6.3.1.dist/adns/dlist.h ircd-hybrid-6.3.1/adns/dlist.h
--- ircd-hybrid-6.3.1.dist/adns/dlist.h	Tue Dec  4 11:12:11 2001
+++ ircd-hybrid-6.3.1/adns/dlist.h	Thu May  8 11:11:11 2003
@@ -32,6 +32,8 @@
 #ifndef ADNS_DLIST_H_INCLUDED
 #define ADNS_DLIST_H_INCLUDED
 
+#define unused_arg /**/
+
 #define DLIST_INIT(list) ((list).head= (list).tail= 0)
 #define DLINK_INIT(link) ((link).next= (link).back= 0)
 
@@ -51,7 +53,7 @@
     (list).tail= (node); \
   } while(0)
 
-#define DLIST_UNLINK(list,node) DLIST_UNLINK_PART(list,node,)
-#define DLIST_LINK_TAIL(list,node) DLIST_LINK_TAIL_PART(list,node,)
+#define DLIST_UNLINK(list,node) DLIST_UNLINK_PART(list,node,unused_arg)
+#define DLIST_LINK_TAIL(list,node) DLIST_LINK_TAIL_PART(list,node,unused_arg)
 
 #endif
diff -uNrd ircd-hybrid-6.3.1.dist/autoconf/acconfig.h ircd-hybrid-6.3.1/autoconf/acconfig.h
--- ircd-hybrid-6.3.1.dist/autoconf/acconfig.h	Sun Dec  9 14:02:06 2001
+++ ircd-hybrid-6.3.1/autoconf/acconfig.h	Sat Apr 19 21:06:44 2003
@@ -30,3 +30,6 @@
 /* Define if you have SYSV non-blocking sockets (FIONBIO) */
 #undef NBLOCK_SYSV
 
+/* Define if you have the setlocale() system call.  */
+#undef USE_SETLOCALE
+
diff -uNrd ircd-hybrid-6.3.1.dist/autoconf/configure.in ircd-hybrid-6.3.1/autoconf/configure.in
--- ircd-hybrid-6.3.1.dist/autoconf/configure.in	Sun Jan 27 23:36:52 2002
+++ ircd-hybrid-6.3.1/autoconf/configure.in	Thu May  8 11:16:50 2003
@@ -1,4 +1,4 @@
-dnl $Id: configure.in,v 1.28 2002/01/28 04:36:52 androsyn Exp $
+dnl $Id: configure.in,v 1.29 2002/07/12 00:04:04 androsyn Exp $
 dnl Process this file with autoconf to produce a configure script.
 AC_INIT(include/class.h)
 
@@ -13,11 +13,12 @@
 dnl Checks for programs.
 AC_PROG_CC
 AC_ISC_POSIX
-AC_CANONICAL_SYSTEM
+dnl AC_CANONICAL_SYSTEM
 AC_PROG_MAKE_SET
 AC_PATH_PROG(RM,rm)
 AC_PATH_PROG(CP,cp)
 AC_PROG_INSTALL
+AC_PROG_RANLIB
 AC_C_INLINE
 
 dnl Checks for libraries.
@@ -28,7 +29,7 @@
 
 dnl Checks for header files.
 AC_HEADER_STDC
-AC_CHECK_HEADERS(sys/param.h sys/select.h errno.h string.h stddef.h getopt.h crypt.h) 
+AC_CHECK_HEADERS(sys/param.h sys/select.h errno.h string.h stddef.h getopt.h crypt.h locale.h) 
 
 dnl Check for stdarg.h - if we can't find it, halt configure
 AC_CHECK_HEADER(stdarg.h, , AC_MSG_ERROR(** stdarg.h could not be found - ircd-hybrid will not compile without it **))
@@ -40,6 +41,9 @@
 dnl for zlib 1.0.2 or higher by looking for zlibVersion().
 AC_CHECK_LIB(z, deflate)
 AC_CHECK_FUNC(zlibVersion, , AC_MSG_WARN(zlib 1.0.2 or higher required for ZIPLINK support))
+
+dnl check for setlocale() call
+AC_CHECK_FUNC(setlocale, AC_DEFINE(USE_SETLOCALE),)
 
 dnl check for poll() call
 AC_CHECK_FUNC(poll, AC_DEFINE(USE_POLL),)
diff -uNrd ircd-hybrid-6.3.1.dist/doc/example.conf ircd-hybrid-6.3.1/doc/example.conf
--- ircd-hybrid-6.3.1.dist/doc/example.conf	Sun Dec 30 02:50:33 2001
+++ ircd-hybrid-6.3.1/doc/example.conf	Tue Apr 22 10:24:57 2003
@@ -189,6 +189,10 @@
 ##
 ## < This user is exempt from idle restrictions if IDLE_CHECK is defined
 ##
+## / This user must have a resolving host to connect to the server
+##
+## { This user is exempt from clone checks if CHECK_CLONE is defined
+##
 
 ## Examples
 ## c) I:NOMATCH::^db@koruna.varner.com::3
@@ -227,6 +231,7 @@
 ##       disable an opers use of /rehash
 ## D/d - allow the use of /die or /restart. Default is d for disallowing
 ##       /die /restart 
+## A/a - allow the use of usermode +a, mark the oper as an admin
 ##
 ## Default flags for opers are GKORUH
 ## Default flags for local ops, KUH
@@ -326,6 +331,10 @@
 # IRC will actively try to connect to that server. You should have at least
 # one such line.
 #
+# If the port number is negative, the server will set the absolute value of
+# the port as the default for that server link, but not actively autoconnect
+# to the server.
+#
 # If an N: line contains four fields, the fourth should contain a number that
 # specifies how many components of your own server's name to strip off the
 # front and be replaced with a *.  This is done to implement hostmasking.
@@ -429,25 +438,8 @@
 #
 d:199.0.154.0/24:Don't D line ais.net:
 
-#
-# server "clusters"
-# U: lines treat each of these servers as being part of your server cluster
-# klines placed on this server will be forwarded to the servers named
-# in the U lines here. LOCOPS will also be forwarded, but will appear
-# as "SLOCOPS" instead of "LOCOPS"
-#
-# i.e. irc_hub.somewhere.net has leaf servers irc1.somewhere.net 
-# irc2.somewhere.net
-
-# Hub server would have
-U:irc1.somewhere.net:
-U:irc2.somewhere.net
-
-# each client server would have
-U:irc_hub.somewhere.net
+# server "clusters" (U: lines) are no longer present.
 
-#
-#
 # Q lines, not the old server Q lines, but Quarantine lines for
 # nicks. Only checked at NICK time, i.e. if added and hashed in
 # will not kill users who match this nick.
diff -uNrd ircd-hybrid-6.3.1.dist/include/channel.h ircd-hybrid-6.3.1/include/channel.h
--- ircd-hybrid-6.3.1.dist/include/channel.h	Thu Dec  6 15:56:08 2001
+++ ircd-hybrid-6.3.1/include/channel.h	Sat Apr 19 21:06:44 2003
@@ -56,7 +56,11 @@
   struct Mode     mode;
   char            topic[TOPICLEN + 1];
 #ifdef TOPIC_INFO
+#ifdef TOPIC_UH
+  char            topic_nick[NICKLEN + HOSTLEN + USERLEN + 3];
+#else
   char            topic_nick[NICKLEN + 1];
+#endif /* TOPIC_UH */
   time_t          topic_time;
 #endif
   int             users;
